<?
class iTunesControll
{

	
	/***
	 *COM Object for iTunes
	 */
	private $iTunesCOM;

	/**
	 *Constructor
	 **/
	function iTunesControll()
	{
		$this->iTunesCOM= new COM('iTunes.Application');
	}
/**
 * returns the current track name
 * 
 */
	function getTrackName()
	{
		return $this->iTunesCOM->CurrentTrack()->Name();
	}
/*
 * Start playing the actual track
 */
	function play()
	{

		$this->iTunesCOM->Play();
	}
/*
 * Sop playing the actual track
 */
	function stop()
	{
		$this->iTunesCOM->Stop();
	}
/*
 * Pause PLaying the actual track
 */
	function pause()
	{
		$this->iTunesCOM->Pause();
	}
/*
 * Skip forward
 */
	function forward()
	{
		$this->iTunesCOM->NextTrack();
	}
/*
 * Skip backward
 */
	function back()
	{
		$this->iTunesCOM->PreviousTrack();
	}
/*
 * Returns an assoative array of play lists
 */
	function &getPlayLists()
	{

		$list = array();
		$sources = $this->iTunesCOM->Sources();
		for ($itemNo = 1; $itemNo <= $sources->Count(); $itemNo++)
		{

			$source = $sources->Item($itemNo);
			$playLists = $source->Playlists();
			for ($y = 1; $y <= $playLists->Count(); $y++)
			{
				$list[$y] = array();
				$list[$y]["NAME"] = $playLists->Item($y)->Name;
				$list[$y]["ID"] = $y;
			}
		}
		return $list;
	}

	function &getPlayList($index)
	{
		$list;
		$sources = $this->iTunesCOM->Sources();
		for ($itemNo = 1; $itemNo <= $sources->Count(); $itemNo++)
		{

			$source = $sources->Item($itemNo);
			$playLists = $source->Playlists();
			for ($y = 1; $y <= $playLists->Count(); $y++)
			{
				if($y==$index)
				{
					$list = $playLists->Item($y);
				}
			}
		}
		return $list;
	}

	function &getTracksFromPlayList($index)
	{
		$library=&$this->getPlayList($index);
		$list = array();
		
		$libraryTracks = $library->Tracks();			//get the track listing
		$trackCount = $libraryTracks->Count();			//how many tracks?
		for ($y = 1; $y <= $trackCount; $y++)
		{

			$track = $libraryTracks->Item($y);
			$list[$y] = array();
			$list[$y]["NAME"] = $track->Name;
			$list[$y]["ALBUM"] = $track->Album;
			$list[$y]["TIME"] = $track->Time;
			$list[$y]["ARTIST"] = $track->Artist;
			$list[$y]["ID"] = $y;

		}
		return $list;
	}

	function playTrack($pl,$track)
	{
		$library=&$this->getPlayList($pl);
		$libraryTracks = $library->Tracks();			//get the track listing
		$libraryTracks->item($track)->Play();
	}

	function &getTracksFromCurrentPlayList()
	{
		$list = array();
		$library = $this->iTunesCOM->CurrentPlayList();		//get the library
		$libraryTracks = $library->Tracks();			//get the track listing
		$trackCount = $libraryTracks->Count();			//how many tracks?
		$list["ID"]=$this->getCurrenPlayListID($library->Name());
		for ($y = 1; $y <= $trackCount; $y++)
		{

			$track = $libraryTracks->Item($y);
			$list[$y] = array();
			$list[$y]["NAME"] = $track->Name;
			$list[$y]["ALBUM"] = $track->Album;
			$list[$y]["TIME"] = $track->Time;
			$list[$y]["ARTIST"] = $track->Artist;
			$list[$y]["ID"] = $y;

		}
		return $list;
	}

	function getCurrenPlayListID($playListName)
	{
		$list = array();
		$sources = $this->iTunesCOM->Sources();
		for ($itemNo = 1; $itemNo <= $sources->Count(); $itemNo++)
		{
			$source = $sources->Item($itemNo);
			$playLists = $source->Playlists();
			for ($y = 1; $y <= $playLists->Count(); $y++)
			{

				if(strcmp($playLists->Item($y)->Name,$playListName)==0)
				{
					return $y;
				}
			}
		}
		return 0;
	}

	function getActualTrackTime()
	{
		$pos=$this->iTunesCOM->PlayerPosition();
		$min=intval($pos/60);
		$sec=$pos%60;
		$retVal= sprintf("%02d:%02d",$min,$sec);
		return($retVal);
	}

	function storeCoverArt($path)
	{
		$track=$this->iTunesCOM->CurrentTrack();
		if($track->Artwork->Count()>0)
		{
			$art=$track->Artwork->Item(1);
			$art->SaveArtworkToFile($path);
			return true;
		}
		else
		{
			return false;
		}
	}

	function hasCoverArt()
	{
		$track=$this->iTunesCOM->CurrentTrack();
		return($track->Artwork->Count()>0);
	}

	function getVolume()
	{
		return $this->iTunesCOM->SoundVolume();
	}

	function setVolume($val)
	{
		$this->iTunesCOM->SoundVolume=$val;
	}

}
?>